/*
 * This is a part of PolyORB-HI-C distribution, a minimal
 * middleware written for generated code from AADL models.
 * You should use it with the Ocarina toolsuite.
 *
 * For more informations, please visit http://www.openaadl.org
 *
 * Copyright (C) 2020 OpenAADL
 */

#if (defined (__PO_HI_NEED_DRIVER_BLUETOOTH))\n
/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>


#include "bluetooth.h"

const __po_hi_c_bluetooth_conf_t crazyflie_default = {
    .channel = 80,
    .datarate = __po_hi_c_d2M,
    .address = {
        {
            0xE7,
            0xE7,
            0xE7,
            0xE7,
            0xE7
        }
    },
    .exist = {
        .datarate = 1,
        .address = 1
    }
};


void __po_hi_c_Datarate_T_Initialize(__po_hi_c_Datarate_T* pVal)
{
	(void)pVal;


	(*(pVal)) = __po_hi_c_d250K;
}

flag __po_hi_c_Datarate_T_IsConstraintValid(const __po_hi_c_Datarate_T* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = ((((((*(pVal)) == __po_hi_c_d250K)) || (((*(pVal)) == __po_hi_c_d1M)))) || (((*(pVal)) == __po_hi_c_d2M)));
    *pErrCode = ret ? 0 :  ERR_DATARATE_T; 

	return ret;
}



void __po_hi_c_Address_T_Initialize(__po_hi_c_Address_T* pVal)
{
	(void)pVal;


	memset(pVal->arr, 0x0, 5);


}

flag __po_hi_c_Address_T_IsConstraintValid(const __po_hi_c_Address_T* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = TRUE;
    *pErrCode = 0;

	return ret;
}



void __po_hi_c_bluetooth_conf_t_channel_Initialize(__po_hi_c_bluetooth_conf_t_channel* pVal)
{
	(void)pVal;


	(*(pVal)) = 0;
}
void __po_hi_c_bluetooth_conf_t_Initialize(__po_hi_c_bluetooth_conf_t* pVal)
{
	(void)pVal;



	/*set channel */
	__po_hi_c_bluetooth_conf_t_channel_Initialize((&(pVal->channel)));
	/*set datarate */
	pVal->exist.datarate = 1;
	pVal->datarate = __po_hi_c_d2M;
	/*set address */
	pVal->exist.address = 1;
	pVal->address.arr[0] = 0xe7;
	pVal->address.arr[1] = 0xe7;
	pVal->address.arr[2] = 0xe7;
	pVal->address.arr[3] = 0xe7;
	pVal->address.arr[4] = 0xe7;
}

flag __po_hi_c_bluetooth_conf_t_IsConstraintValid(const __po_hi_c_bluetooth_conf_t* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = (pVal->channel <= 125UL);
    *pErrCode = ret ? 0 :  ERR_BLUETOOTH_CONF_T_CHANNEL; 
    if (ret) {
        if (pVal->exist.datarate) {
        	ret = (((((pVal->datarate == __po_hi_c_d250K)) || ((pVal->datarate == __po_hi_c_d1M)))) || ((pVal->datarate == __po_hi_c_d2M)));
        	*pErrCode = ret ? 0 :  ERR_BLUETOOTH_CONF_T_DATARATE; 
        }
    }

	return ret;
}

\n#endif
